Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1200)
@@ -2278,73 +2233,8 @@
   }
 }
-
-Void TComVPS::deleteCamPars()
-{
-  Int iNumViews = getNumViews();
-  Int i = 0, j = 0;
-
-  if ( m_numCp != NULL )
-  {
-    delete [] m_numCp;
-  }
-
-  if ( m_cpRefVoi != NULL )
-  {
-    for ( i = 0; i < iNumViews ; i++ )
-    {
-      delete [] m_cpRefVoi[i];
-    }
-    delete[] m_cpRefVoi; 
-  }
-
-  if ( m_cpPresentFlag != NULL )
-  {
-    for ( i = 0; i < iNumViews ; i++ )
-    {
-      delete [] m_cpPresentFlag[i];
-    }
-    delete[] m_cpPresentFlag; 
-  }
-
-
-  if ( m_cpInSliceSegmentHeaderFlag != NULL )
-  {
-    delete [] m_cpInSliceSegmentHeaderFlag;
-  }
-
-
-  if ( m_aaaiCodedScale != NULL )
-  {
-    for ( i = 0; i < iNumViews ; i++ )
-    {
-      for ( j = 0; j < 2; j++ )
-      {
-        delete [] m_aaaiCodedScale[i][j];
-      }
-      delete [] m_aaaiCodedScale[i];
-    }
-    delete [] m_aaaiCodedScale;
-  }
-
-  if ( m_aaaiCodedOffset != NULL )
-  {
-    for ( i = 0; i < iNumViews ; i++ )
-    {
-      for ( j = 0; j < 2; j++ )
-      {
-        delete [] m_aaaiCodedOffset[i][j];
-      }
-      delete [] m_aaaiCodedOffset[i];
-    }
-    delete [] m_aaaiCodedOffset;
-  }
-}
-
-
-
 #endif // H_3D
 
 
-Int TComVPS::xGetDimBitOffset( Int j )
+Int TComVPS::xGetDimBitOffset( Int j ) const
 {
   Int dimBitOffset = 0; 
@@ -2363,15 +2253,15 @@
 }
 
-Int TComVPS::inferDimensionId( Int i, Int j )
+Int TComVPS::inferDimensionId( Int i, Int j ) const
 {
     return ( ( getLayerIdInNuh( i ) & ( (1 << xGetDimBitOffset( j + 1 ) ) - 1) ) >> xGetDimBitOffset( j ) ); 
 }
 
-Int TComVPS::inferLastDimsionIdLenMinus1()
+Int TComVPS::inferLastDimsionIdLenMinus1() const
 {
   return ( 5 - xGetDimBitOffset( getNumScalabilityTypes() - 1 ) ); 
 }
 
-Int TComVPS::getNumLayersInIdList( Int lsIdx )
+Int TComVPS::getNumLayersInIdList( Int lsIdx ) const
 {
   assert( lsIdx >= 0 ); 
@@ -2380,5 +2270,5 @@
 }
 
-Int    TComVPS::getNumOutputLayerSets() 
+Int    TComVPS::getNumOutputLayerSets() const
 {
   return getNumAddOlss() + getNumLayerSets(); 
@@ -2427,5 +2317,5 @@
 }
 
-Bool TComVPS::inferOutputLayerFlag( Int i, Int j )
+Bool TComVPS::inferOutputLayerFlag( Int i, Int j ) const
 {
   Bool outputLayerFlag; 
@@ -2455,5 +2345,5 @@
 }
 
-Int TComVPS::getMaxSubLayersInLayerSetMinus1( Int i )
+Int TComVPS::getMaxSubLayersInLayerSetMinus1( Int i ) const
 {
   Int maxSLMinus1 = 0; 
@@ -2466,5 +2356,5 @@
 }
 
-Bool TComVPS::getAltOutputLayerFlagVar( Int i )
+Bool TComVPS::getAltOutputLayerFlagVar( Int i ) const
 {
   // Semantics variable not syntax element !
@@ -2481,5 +2371,5 @@
 
 
-Int TComVPS::inferProfileTierLevelIdx(Int i, Int j)
+Int TComVPS::inferProfileTierLevelIdx(Int i, Int j) const
 {
   Bool inferZero        = ( i == 0 && j == 0 &&  getVpsBaseLayerInternalFlag() );
@@ -2555,9 +2445,9 @@
 }
 
-Void TComVPS::printPTL()
+Void TComVPS::printPTL() const
 {
   std::vector<Int> idx; 
   std::vector<Int> num; 
-  std::vector< std::vector<Int> > ptlInfo; 
+  IntAry2d ptlInfo; 
 
   std::cout << std::right << std::setw(60) << std::setfill('-') << " " << std::setfill(' ') << std::endl << "PTLI" << std::endl; 
@@ -2566,5 +2456,5 @@
   {
     std::vector<Int> curPtlInfo;
-    ProfileTierLevel* ptl = getPTL( i )->getGeneralPTL(); 
+    const ProfileTierLevel* ptl = getPTL( i )->getGeneralPTL(); 
     curPtlInfo.push_back( (Int) ptl->getProfileIdc()  );
     curPtlInfo.push_back( (Int) ptl->getTierFlag()    );
@@ -2591,10 +2481,10 @@
 }
 
-Void TComVPS::printLayerDependencies()
+Void TComVPS::printLayerDependencies() const
 {
   vector<Int> fullArray;
   vector<Int> range; 
 
-#if H_3D
+#if NH_3D
   vector<Int> depthId; 
 #endif
@@ -2623,5 +2513,5 @@
   xPrintArray( "IdRefLayer"      , getMaxLayersMinus1() + 1, m_layerIdInNuh, m_numRefLayers, m_idRefLayer, true );
   xPrintArray( "IdDirectRefLayer", getMaxLayersMinus1() + 1, m_layerIdInNuh, m_numDirectRefLayers, m_idDirectRefLayer, true );
-#if H_3D
+#if NH_3D
   xPrintArray( "IdRefListLayer", getMaxLayersMinus1() + 1, m_layerIdInNuh, m_numRefListLayers, m_idRefListLayer, true );
 #endif
@@ -2630,12 +2520,10 @@
 }
 
-Void TComVPS::printScalabilityId()
+Void TComVPS::printScalabilityId() const
 {
   vector<Int> layerIdxInVps; 
 
-#if H_3D
+
   vector<Int> depthId; 
-#endif
-
   vector<Int> viewOrderIndex;
   vector<Int> auxId;
@@ -2647,11 +2535,10 @@
     Int layerIdInNuh = getLayerIdInNuh( i );
     layerIdxInVps  .push_back( i ); 
+    depthId       .push_back( getDepthId     ( layerIdInNuh ) );
     viewOrderIndex.push_back( getViewIndex   ( layerIdInNuh ) );
     dependencyId  .push_back( getDependencyId( layerIdInNuh ) );
     auxId         .push_back( getAuxId       ( layerIdInNuh ) );      
     viewId        .push_back( getViewId      ( layerIdInNuh ) );
-#if H_3D  
-    depthId       .push_back( getDepthId     ( layerIdInNuh ) );
-#endif
+
   }
 
@@ -2660,13 +2547,14 @@
   xPrintArray( "layer_id_in_nuh", getMaxLayersMinus1()+1, m_layerIdInNuh, false );     
 
-  xPrintArray( "ViewOrderIndex", getMaxLayersMinus1()+1, viewOrderIndex, false );     
+  xPrintArray( "DepthLayerFlag", getMaxLayersMinus1()+1, depthId       , false );     
+  xPrintArray( "ViewOrderIdx"  , getMaxLayersMinus1()+1, viewOrderIndex, false );     
   xPrintArray( "DependencyId"  , getMaxLayersMinus1()+1, dependencyId  , false );     
   xPrintArray( "AuxId"         , getMaxLayersMinus1()+1, auxId         , false );     
-  xPrintArray( "ViewId"        , getMaxLayersMinus1()+1, viewId        , false );     
+  xPrintArray( "ViewIdVal"     , getMaxLayersMinus1()+1, viewId        , false );     
 
   std::cout << std::endl;
 }
 
-Void TComVPS::printLayerSets()
+Void TComVPS::printLayerSets() const
 {
   vector<Int> fullArray;
@@ -2721,5 +2609,5 @@
 }
 
-#if H_3D
+#if NH_3D
 Void TComVPS::initViewCompLayer()
 {
@@ -2749,5 +2637,5 @@
 }
 
-Int TComVPS::getVoiInVps(Int viewOIdx)
+Int TComVPS::getVoiInVps(Int viewOIdx) const
 {
   for ( Int i = 0; i < m_viewOIdxList.size(); i++ )
@@ -2783,9 +2671,25 @@
 #endif
 
-#endif // H_MV
+#endif // NH_MV
 
 // ------------------------------------------------------------------------------------------------
 // Sequence parameter set (SPS)
 // ------------------------------------------------------------------------------------------------
+
+TComSPSRExt::TComSPSRExt()
+ : m_transformSkipRotationEnabledFlag   (false)
+ , m_transformSkipContextEnabledFlag    (false)
+// m_rdpcmEnabledFlag initialized below
+ , m_extendedPrecisionProcessingFlag    (false)
+ , m_intraSmoothingDisabledFlag         (false)
+ , m_highPrecisionOffsetsEnabledFlag    (false)
+ , m_persistentRiceAdaptationEnabledFlag(false)
+ , m_cabacBypassAlignmentEnabledFlag    (false)
+{
+  for (UInt signallingModeIndex = 0; signallingModeIndex < NUMBER_OF_RDPCM_SIGNALLING_MODES; signallingModeIndex++)
+  {
+    m_rdpcmEnabledFlag[signallingModeIndex] = false;
+  }
+}
 
 TComSPS::TComSPS()
@@ -2798,8 +2702,8 @@
 , m_picHeightInLumaSamples    (288)
 , m_log2MinCodingBlockSize    (  0)
-, m_log2DiffMaxMinCodingBlockSize (0)
+, m_log2DiffMaxMinCodingBlockSize(0)
 , m_uiMaxCUWidth              ( 32)
 , m_uiMaxCUHeight             ( 32)
-, m_uiMaxCUDepth              (  3)
+, m_uiMaxTotalCUDepth         (  3)
 , m_bLongTermRefsPresent      (false)
 , m_uiQuadtreeTULog2MaxSize   (  0)
@@ -2808,18 +2712,12 @@
 , m_uiQuadtreeTUMaxDepthIntra (  0)
 // Tool list
-, m_usePCM                   (false)
+, m_usePCM                    (false)
 , m_pcmLog2MaxSize            (  5)
 , m_uiPCMLog2MinSize          (  7)
-, m_bitDepthY                 (  8)
-, m_bitDepthC                 (  8)
-, m_qpBDOffsetY               (  0)
-, m_qpBDOffsetC               (  0)
-, m_uiPCMBitDepthLuma         (  8)
-, m_uiPCMBitDepthChroma       (  8)
 , m_bPCMFilterDisableFlag     (false)
 , m_uiBitsForPOC              (  8)
-, m_numLongTermRefPicSPS    (  0)  
+, m_numLongTermRefPicSPS      (  0)
 , m_uiMaxTrSize               ( 32)
-, m_bUseSAO                   (false) 
+, m_bUseSAO                   (false)
 , m_bTemporalIdNestingFlag    (false)
 , m_scalingListEnabledFlag    (false)
@@ -2827,5 +2725,5 @@
 , m_vuiParametersPresentFlag  (false)
 , m_vuiParameters             ()
-#if H_MV
+#if NH_MV
 , m_pcVPS                     ( NULL )
 , m_spsInferScalingListFlag   ( false )
@@ -2836,5 +2734,17 @@
 , m_interViewMvVertConstraintFlag (false)
 #endif
-{
+
+{
+  for(Int ch=0; ch<MAX_NUM_CHANNEL_TYPE; ch++)
+  {
+    m_bitDepths.recon[ch] = 8;
+#if O0043_BEST_EFFORT_DECODING
+    m_bitDepths.stream[ch] = 8;
+#endif
+    m_pcmBitDepths[ch] = 8;
+    m_qpBDOffset   [ch] = 0;
+  }
+
+
   for ( Int i = 0; i < MAX_TLAYER; i++ )
   {
@@ -2843,194 +2753,95 @@
     m_numReorderPics[i]       = 0;
   }
-  m_scalingList = new TComScalingList;
+
   ::memset(m_ltRefPicPocLsbSps, 0, sizeof(m_ltRefPicPocLsbSps));
   ::memset(m_usedByCurrPicLtSPSFlag, 0, sizeof(m_usedByCurrPicLtSPSFlag));
-#if H_MV
+#if NH_MV
   m_spsRangeExtensionsFlag     = false;
   m_spsMultilayerExtensionFlag = false;
-#if H_3D
   m_spsExtension5bits          = 0;
   m_sps3dExtensionFlag         = false; 
-#else
-  m_spsExtension6bits          = 0;
-#endif
-
-#endif
+
+#endif
+
 }
 
 TComSPS::~TComSPS()
 {
-  delete m_scalingList;
   m_RPSList.destroy();
 }
 
 Void  TComSPS::createRPSList( Int numRPS )
-{ 
+{
   m_RPSList.destroy();
   m_RPSList.create(numRPS);
 }
 
-Void TComSPS::setHrdParameters( UInt frameRate, UInt numDU, UInt bitRate, Bool randomAccess )
-{
-  if( !getVuiParametersPresentFlag() )
-  {
-    return;
-  }
-
-  TComVUI *vui = getVuiParameters();
-  TComHRD *hrd = vui->getHrdParameters();
-
-  TimingInfo *timingInfo = vui->getTimingInfo();
-  timingInfo->setTimingInfoPresentFlag( true );
-  switch( frameRate )
-  {
-  case 24:
-    timingInfo->setNumUnitsInTick( 1125000 );    timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 25:
-    timingInfo->setNumUnitsInTick( 1080000 );    timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 30:
-    timingInfo->setNumUnitsInTick( 900900 );     timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 50:
-    timingInfo->setNumUnitsInTick( 540000 );     timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 60:
-    timingInfo->setNumUnitsInTick( 450450 );     timingInfo->setTimeScale    ( 27000000 );
-    break;
-  default:
-    timingInfo->setNumUnitsInTick( 1001 );       timingInfo->setTimeScale    ( 60000 );
-    break;
-  }
-
-  Bool rateCnt = ( bitRate > 0 );
-  hrd->setNalHrdParametersPresentFlag( rateCnt );
-  hrd->setVclHrdParametersPresentFlag( rateCnt );
-
-  hrd->setSubPicCpbParamsPresentFlag( ( numDU > 1 ) );
-
-  if( hrd->getSubPicCpbParamsPresentFlag() )
-  {
-    hrd->setTickDivisorMinus2( 100 - 2 );                          // 
-    hrd->setDuCpbRemovalDelayLengthMinus1( 7 );                    // 8-bit precision ( plus 1 for last DU in AU )
-    hrd->setSubPicCpbParamsInPicTimingSEIFlag( true );
-    hrd->setDpbOutputDelayDuLengthMinus1( 5 + 7 );                 // With sub-clock tick factor of 100, at least 7 bits to have the same value as AU dpb delay
-  }
-  else
-  {
-    hrd->setSubPicCpbParamsInPicTimingSEIFlag( false );  
-  }
-
-  hrd->setBitRateScale( 4 );                                       // in units of 2~( 6 + 4 ) = 1,024 bps
-  hrd->setCpbSizeScale( 6 );                                       // in units of 2~( 4 + 4 ) = 1,024 bit
-  hrd->setDuCpbSizeScale( 6 );                                       // in units of 2~( 4 + 4 ) = 1,024 bit
-  
-  hrd->setInitialCpbRemovalDelayLengthMinus1(15);                  // assuming 0.5 sec, log2( 90,000 * 0.5 ) = 16-bit
-  if( randomAccess )
-  {
-    hrd->setCpbRemovalDelayLengthMinus1(5);                        // 32 = 2^5 (plus 1)
-    hrd->setDpbOutputDelayLengthMinus1 (5);                        // 32 + 3 = 2^6
-  }
-  else
-  {
-    hrd->setCpbRemovalDelayLengthMinus1(9);                        // max. 2^10
-    hrd->setDpbOutputDelayLengthMinus1 (9);                        // max. 2^10
-  }
-
-/*
-   Note: only the case of "vps_max_temporal_layers_minus1 = 0" is supported.
-*/
-  Int i, j;
-  UInt birateValue, cpbSizeValue;
-  UInt ducpbSizeValue;
-  UInt duBitRateValue = 0;
-
-  for( i = 0; i < MAX_TLAYER; i ++ )
-  {
-    hrd->setFixedPicRateFlag( i, 1 );
-    hrd->setPicDurationInTcMinus1( i, 0 );
-    hrd->setLowDelayHrdFlag( i, 0 );
-    hrd->setCpbCntMinus1( i, 0 );
-
-    birateValue  = bitRate;
-    cpbSizeValue = bitRate;                                     // 1 second
-    ducpbSizeValue = bitRate/numDU;
-    duBitRateValue = bitRate;
-    for( j = 0; j < ( hrd->getCpbCntMinus1( i ) + 1 ); j ++ )
-    {
-      hrd->setBitRateValueMinus1( i, j, 0, ( birateValue  - 1 ) );
-      hrd->setCpbSizeValueMinus1( i, j, 0, ( cpbSizeValue - 1 ) );
-      hrd->setDuCpbSizeValueMinus1( i, j, 0, ( ducpbSizeValue - 1 ) );
-      hrd->setCbrFlag( i, j, 0, ( j == 0 ) );
-
-      hrd->setBitRateValueMinus1( i, j, 1, ( birateValue  - 1) );
-      hrd->setCpbSizeValueMinus1( i, j, 1, ( cpbSizeValue - 1 ) );
-      hrd->setDuCpbSizeValueMinus1( i, j, 1, ( ducpbSizeValue - 1 ) );
-      hrd->setDuBitRateValueMinus1( i, j, 1, ( duBitRateValue - 1 ) );
-      hrd->setCbrFlag( i, j, 1, ( j == 0 ) );
-    }
-  }
-}
 const Int TComSPS::m_winUnitX[]={1,2,2,1};
 const Int TComSPS::m_winUnitY[]={1,2,1,1};
 
+TComPPSRExt::TComPPSRExt()
+: m_log2MaxTransformSkipBlockSize      (2)
+, m_crossComponentPredictionEnabledFlag(false)
+, m_diffCuChromaQpOffsetDepth          (0)
+, m_chromaQpOffsetListLen              (0)
+// m_ChromaQpAdjTableIncludingNullEntry initialized below
+// m_log2SaoOffsetScale initialized below
+{
+  m_ChromaQpAdjTableIncludingNullEntry[0].u.comp.CbOffset = 0; // Array includes entry [0] for the null offset used when cu_chroma_qp_offset_flag=0. This is initialised here and never subsequently changed.
+  m_ChromaQpAdjTableIncludingNullEntry[0].u.comp.CrOffset = 0;
+  for(Int ch=0; ch<MAX_NUM_CHANNEL_TYPE; ch++)
+  {
+    m_log2SaoOffsetScale[ch] = 0;
+  }
+}
+
 TComPPS::TComPPS()
-: m_PPSId                       (0)
-, m_SPSId                       (0)
-, m_picInitQPMinus26            (0)
-, m_useDQP                      (false)
-, m_bConstrainedIntraPred       (false)
-, m_bSliceChromaQpFlag          (false)
-, m_pcSPS                       (NULL)
-, m_uiMaxCuDQPDepth             (0)
-, m_uiMinCuDQPSize              (0)
-, m_chromaCbQpOffset            (0)
-, m_chromaCrQpOffset            (0)
-, m_numRefIdxL0DefaultActive    (1)
-, m_numRefIdxL1DefaultActive    (1)
-, m_TransquantBypassEnableFlag  (false)
-, m_useTransformSkip             (false)
-, m_dependentSliceSegmentsEnabledFlag    (false)
-, m_tilesEnabledFlag               (false)
-, m_entropyCodingSyncEnabledFlag   (false)
-, m_loopFilterAcrossTilesEnabledFlag  (true)
-, m_uniformSpacingFlag           (false)
-, m_numTileColumnsMinus1         (0)
-, m_numTileRowsMinus1            (0)
-, m_numSubstreams               (1)
-, m_signHideFlag(0)
-, m_cabacInitPresentFlag        (false)
-, m_encCABACTableIdx            (I_SLICE)
-, m_sliceHeaderExtensionPresentFlag    (false)
-, m_loopFilterAcrossSlicesEnabledFlag (false)
-, m_listsModificationPresentFlag(  0)
-, m_numExtraSliceHeaderBits(0)
-#if H_MV
-, m_ppsInferScalingListFlag(false)
-, m_ppsScalingListRefLayerId(0)
-, m_pocResetInfoPresentFlag(false)
+: m_PPSId                            (0)
+, m_SPSId                            (0)
+, m_picInitQPMinus26                 (0)
+, m_useDQP                           (false)
+, m_bConstrainedIntraPred            (false)
+, m_bSliceChromaQpFlag               (false)
+, m_uiMaxCuDQPDepth                  (0)
+, m_chromaCbQpOffset                 (0)
+, m_chromaCrQpOffset                 (0)
+, m_numRefIdxL0DefaultActive         (1)
+, m_numRefIdxL1DefaultActive         (1)
+, m_TransquantBypassEnableFlag       (false)
+, m_useTransformSkip                 (false)
+, m_dependentSliceSegmentsEnabledFlag(false)
+, m_tilesEnabledFlag                 (false)
+, m_entropyCodingSyncEnabledFlag     (false)
+, m_loopFilterAcrossTilesEnabledFlag (true)
+, m_uniformSpacingFlag               (false)
+, m_numTileColumnsMinus1             (0)
+, m_numTileRowsMinus1                (0)
+, m_signHideFlag                     (false)
+, m_cabacInitPresentFlag             (false)
+, m_sliceHeaderExtensionPresentFlag  (false)
+, m_loopFilterAcrossSlicesEnabledFlag(false)
+, m_listsModificationPresentFlag     (0)
+, m_numExtraSliceHeaderBits          (0)
+#if NH_MV
+, m_ppsInferScalingListFlag          (false)
+, m_ppsScalingListRefLayerId         (0)
+, m_pocResetInfoPresentFlag          (false)
 #if H_3D
 , m_pcDLT(NULL)
 #endif
 #endif
-{
-  m_scalingList = new TComScalingList;
-
-#if H_MV
+
+{
+#if NH_MV
   m_ppsRangeExtensionsFlag     = false;
   m_ppsMultilayerExtensionFlag = false;
-#if !H_3D
-  m_ppsExtension6bits          = 0;
-#else
   m_pps3dExtensionFlag         = false;
   m_ppsExtension5bits          = 0;
 #endif
-#endif
+
 }
 
 TComPPS::~TComPPS()
 {
-  delete m_scalingList;
 }
 
@@ -3192,31 +3003,50 @@
 #endif
 
-#if H_MV
-Void TComSPS::inferRepFormat( TComVPS* vps, Int layerIdCurr )
+#if NH_MV
+Void TComSPS::inferRepFormat( TComVPS* vps, Int layerIdCurr, Bool encoder )
 {
   if ( getMultiLayerExtSpsFlag() )
-  { 
+  {    
     Int            repFormatIdx = getUpdateRepFormatFlag() ?  getSpsRepFormatIdx() : vps->getVpsRepFormatIdx( vps->getLayerIdInVps( layerIdCurr ) ) ;
-    TComRepFormat* repFormat    = vps->getRepFormat( repFormatIdx ); 
-    setChromaFormatIdc( repFormat->getChromaFormatVpsIdc() );         
-    //// ToDo: add when supported: 
-    // setSeperateColourPlaneFlag( repFormat->getSeparateColourPlaneVpsFlag() ) ; 
-
-    setPicWidthInLumaSamples ( repFormat->getPicWidthVpsInLumaSamples()  ); 
-    setPicHeightInLumaSamples( repFormat->getPicHeightVpsInLumaSamples() ); 
-
-    setBitDepthY             ( repFormat->getBitDepthVpsLumaMinus8()   + 8 ); 
-    setQpBDOffsetY           ( (Int) (6*( getBitDepthY() - 8 )) );
-
-    setBitDepthC             ( repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
-    setQpBDOffsetC           ( (Int) (6* ( getBitDepthC() -8 ) ) );
-    Window &spsConf    = getConformanceWindow();    
-
-    // Scaled later
-    spsConf.setScaledFlag( false ); 
-    spsConf.setWindowLeftOffset  ( repFormat->getConfWinVpsLeftOffset()    );
-    spsConf.setWindowRightOffset ( repFormat->getConfWinVpsRightOffset()   );
-    spsConf.setWindowTopOffset   ( repFormat->getConfWinVpsTopOffset()     );
-    spsConf.setWindowBottomOffset( repFormat->getConfWinVpsBottomOffset()  );    
+    const TComRepFormat* repFormat    = vps->getRepFormat( repFormatIdx ); 
+
+    if ( encoder )
+    {
+      assert( getChromaFormatIdc() ==  (ChromaFormat) repFormat->getChromaFormatVpsIdc() );         
+      //// ToDo: add when supported: 
+      // assert( getSeperateColourPlaneFlag( repFormat->getSeparateColourPlaneVpsFlag() ) ; 
+
+      assert( getPicWidthInLumaSamples()  ==  repFormat->getPicWidthVpsInLumaSamples()  ); 
+      assert( getPicHeightInLumaSamples() == repFormat->getPicHeightVpsInLumaSamples() ); 
+
+      assert( getBitDepth              ( CHANNEL_TYPE_LUMA ) == repFormat->getBitDepthVpsLumaMinus8()   + 8 ); 
+      assert( getQpBDOffset            ( CHANNEL_TYPE_LUMA ) == (Int) (6*( getBitDepth( CHANNEL_TYPE_LUMA ) - 8 )) );
+
+      assert( getBitDepth              ( CHANNEL_TYPE_CHROMA ) == repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
+      assert( getQpBDOffset            ( CHANNEL_TYPE_CHROMA ) == (Int) (6* ( getBitDepth( CHANNEL_TYPE_CHROMA ) -8 ) ) );
+    }
+    else
+    {
+      setChromaFormatIdc( (ChromaFormat) repFormat->getChromaFormatVpsIdc() );         
+      //// ToDo: add when supported: 
+      // setSeperateColourPlaneFlag( repFormat->getSeparateColourPlaneVpsFlag() ) ; 
+
+      setPicWidthInLumaSamples ( repFormat->getPicWidthVpsInLumaSamples()  ); 
+      setPicHeightInLumaSamples( repFormat->getPicHeightVpsInLumaSamples() ); 
+
+      setBitDepth              ( CHANNEL_TYPE_LUMA, repFormat->getBitDepthVpsLumaMinus8()   + 8 ); 
+      setQpBDOffset            ( CHANNEL_TYPE_LUMA, (Int) (6*( getBitDepth( CHANNEL_TYPE_LUMA ) - 8 )) );
+
+      setBitDepth              ( CHANNEL_TYPE_CHROMA, repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
+      setQpBDOffset            ( CHANNEL_TYPE_CHROMA, (Int) (6* ( getBitDepth( CHANNEL_TYPE_CHROMA ) -8 ) ) );
+      Window &spsConf    = getConformanceWindow();    
+
+      // Scaled later
+      spsConf.setScaledFlag( false ); 
+      spsConf.setWindowLeftOffset  ( repFormat->getConfWinVpsLeftOffset()    );
+      spsConf.setWindowRightOffset ( repFormat->getConfWinVpsRightOffset()   );
+      spsConf.setWindowTopOffset   ( repFormat->getConfWinVpsTopOffset()     );
+      spsConf.setWindowBottomOffset( repFormat->getConfWinVpsBottomOffset()  );            
+    }
 
    if ( getMultiLayerExtSpsFlag() && getUpdateRepFormatFlag() )
@@ -3229,6 +3059,6 @@
       assert( getPicHeightInLumaSamples() <= repFormat->getPicHeightVpsInLumaSamples()   ); 
 
-      assert( getBitDepthY()              <= repFormat->getBitDepthVpsLumaMinus8()   + 8 );         
-      assert( getBitDepthC()              <= repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
+      assert( getBitDepth( CHANNEL_TYPE_LUMA   )  <= repFormat->getBitDepthVpsLumaMinus8()   + 8 );         
+      assert( getBitDepth( CHANNEL_TYPE_CHROMA )  <= repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
     }
   }
@@ -3238,7 +3068,19 @@
   getConformanceWindow().scaleOffsets( scal );
   getVuiParameters()->getDefaultDisplayWindow().scaleOffsets( scal );
-}
-
-Void TComSPS::inferScalingList( TComSPS* spsSrc )
+
+  if (encoder && getMultiLayerExtSpsFlag() )
+  { 
+    Int            repFormatIdx = getUpdateRepFormatFlag() ?  getSpsRepFormatIdx() : vps->getVpsRepFormatIdx( vps->getLayerIdInVps( layerIdCurr ) ) ;
+    const TComRepFormat* repFormat    = vps->getRepFormat( repFormatIdx ); 
+
+    Window &spsConf    = getConformanceWindow();    
+    assert( spsConf.getWindowLeftOffset  () == repFormat->getConfWinVpsLeftOffset()    );
+    assert( spsConf.getWindowRightOffset () == repFormat->getConfWinVpsRightOffset()   );
+    assert( spsConf.getWindowTopOffset   () == repFormat->getConfWinVpsTopOffset()     );
+    assert( spsConf.getWindowBottomOffset() == repFormat->getConfWinVpsBottomOffset()  );            
+  }
+}
+
+Void TComSPS::inferScalingList( const TComSPS* spsSrc )
 {
   if ( getSpsInferScalingListFlag() ) 
@@ -3246,5 +3088,5 @@
     assert( spsSrc != NULL ); 
     assert( !spsSrc->getSpsInferScalingListFlag() );             
-    getScalingList()->inferFrom( spsSrc->getScalingList() ); 
+    getScalingList().inferFrom( (spsSrc->getScalingList()) ); 
   }
 }
@@ -3294,9 +3136,9 @@
 }
 
-Void TComSPS::checkRpsMaxNumPics( TComVPS* vps, Int currLayerId )
+Void TComSPS::checkRpsMaxNumPics( const TComVPS* vps, Int currLayerId ) const
 {
   for (Int i = 0; i < getRPSList()->getNumberOfReferencePictureSets(); i++ )
   {
-    TComReferencePictureSet* rps = getRPSList()->getReferencePictureSet( i ); 
+    const TComReferencePictureSet* rps = getRPSList()->getReferencePictureSet( i ); 
     if ( !rps->getInterRPSPrediction() )
     {
@@ -3327,4 +3169,5 @@
 }
 #endif
+
 
 TComReferencePictureSet::TComReferencePictureSet()
@@ -3333,8 +3176,8 @@
 , m_numberOfPositivePictures (0)
 , m_numberOfLongtermPictures (0)
-, m_interRPSPrediction (0) 
-, m_deltaRIdxMinus1 (0)   
-, m_deltaRPS (0) 
-, m_numRefIdc (0) 
+, m_interRPSPrediction (0)
+, m_deltaRIdxMinus1 (0)
+, m_deltaRPS (0)
+, m_numRefIdc (0)
 {
   ::memset( m_deltaPOC, 0, sizeof(m_deltaPOC) );
@@ -3342,4 +3185,8 @@
   ::memset( m_used, 0, sizeof(m_used) );
   ::memset( m_refIdc, 0, sizeof(m_refIdc) );
+  ::memset( m_bCheckLTMSB, 0, sizeof(m_bCheckLTMSB) );
+  ::memset( m_pocLSBLT, 0, sizeof(m_pocLSBLT) );
+  ::memset( m_deltaPOCMSBCycleLT, 0, sizeof(m_deltaPOCMSBCycleLT) );
+  ::memset( m_deltaPocMSBPresentFlag, 0, sizeof(m_deltaPocMSBPresentFlag) );
 }
 
@@ -3363,20 +3210,20 @@
 }
 
-Int TComReferencePictureSet::getUsed(Int bufferNum)
+Int TComReferencePictureSet::getUsed(Int bufferNum) const
 {
   return m_used[bufferNum];
 }
 
-Int TComReferencePictureSet::getDeltaPOC(Int bufferNum)
+Int TComReferencePictureSet::getDeltaPOC(Int bufferNum) const
 {
   return m_deltaPOC[bufferNum];
 }
 
-Int TComReferencePictureSet::getNumberOfPictures()
+Int TComReferencePictureSet::getNumberOfPictures() const
 {
   return m_numberOfPictures;
 }
 
-Int TComReferencePictureSet::getPOC(Int bufferNum)
+Int TComReferencePictureSet::getPOC(Int bufferNum) const
 {
   return m_POC[bufferNum];
@@ -3388,5 +3235,5 @@
 }
 
-Bool TComReferencePictureSet::getCheckLTMSBPresent(Int bufferNum)
+Bool TComReferencePictureSet::getCheckLTMSBPresent(Int bufferNum) const
 {
   return m_bCheckLTMSB[bufferNum];
@@ -3398,9 +3245,5 @@
 }
 
-/** set the reference idc value at uiBufferNum entry to the value of iRefIdc
- * \param uiBufferNum
- * \param iRefIdc
- * \returns Void
- */
+//! set the reference idc value at uiBufferNum entry to the value of iRefIdc
 Void TComReferencePictureSet::setRefIdc(Int bufferNum, Int refIdc)
 {
@@ -3408,9 +3251,6 @@
 }
 
-/** get the reference idc value at uiBufferNum
- * \param uiBufferNum
- * \returns Int
- */
-Int  TComReferencePictureSet::getRefIdc(Int bufferNum)
+//! get the reference idc value at uiBufferNum
+Int  TComReferencePictureSet::getRefIdc(Int bufferNum) const
 {
   return m_refIdc[bufferNum];
@@ -3426,5 +3266,5 @@
   // sort in increasing order (smallest first)
   for(Int j=1; j < getNumberOfPictures(); j++)
-  { 
+  {
     Int deltaPOC = getDeltaPOC(j);
     Bool used = getUsed(j);
@@ -3444,5 +3284,5 @@
   Int numNegPics = getNumberOfNegativePictures();
   for(Int j=0, k=numNegPics-1; j < numNegPics>>1; j++, k--)
-  { 
+  {
     Int deltaPOC = getDeltaPOC(j);
     Bool used = getUsed(j);
@@ -3458,5 +3298,5 @@
  * \returns Void
  */
-Void TComReferencePictureSet::printDeltaPOC()
+Void TComReferencePictureSet::printDeltaPOC() const
 {
   printf("DeltaPOC = { ");
@@ -3464,6 +3304,6 @@
   {
     printf("%d%s ", getDeltaPOC(j), (getUsed(j)==1)?"*":"");
-  } 
-  if (getInterRPSPrediction()) 
+  }
+  if (getInterRPSPrediction())
   {
     printf("}, RefIdc = { ");
@@ -3471,10 +3311,11 @@
     {
       printf("%d ", getRefIdc(j));
-    } 
+    }
   }
   printf("}\n");
 }
-#if H_MV
-Void TComReferencePictureSet::checkMaxNumPics( Bool vpsExtensionFlag, Int maxNumPics, Int nuhLayerId, Int spsMaxDecPicBufferingMinus1 )
+
+#if NH_MV
+Void TComReferencePictureSet::checkMaxNumPics( Bool vpsExtensionFlag, Int maxNumPics, Int nuhLayerId, Int spsMaxDecPicBufferingMinus1 ) const
 {
   assert( getNumberOfPictures() >= 0 ); 
@@ -3491,49 +3332,10 @@
 #endif
 
-TComRPSList::TComRPSList()
-:m_referencePictureSets (NULL)
-{
-}
-
-TComRPSList::~TComRPSList()
-{
-}
-
-Void TComRPSList::create( Int numberOfReferencePictureSets)
-{
-  m_numberOfReferencePictureSets = numberOfReferencePictureSets;
-  m_referencePictureSets = new TComReferencePictureSet[numberOfReferencePictureSets];
-}
-
-Void TComRPSList::destroy()
-{
-  if (m_referencePictureSets)
-  {
-    delete [] m_referencePictureSets;
-  }
-  m_numberOfReferencePictureSets = 0;
-  m_referencePictureSets = NULL;
-}
-
-
-
-TComReferencePictureSet* TComRPSList::getReferencePictureSet(Int referencePictureSetNum)
-{
-  return &m_referencePictureSets[referencePictureSetNum];
-}
-
-Int TComRPSList::getNumberOfReferencePictureSets()
-{
-  return m_numberOfReferencePictureSets;
-}
-
-Void TComRPSList::setNumberOfReferencePictureSets(Int numberOfReferencePictureSets)
-{
-  m_numberOfReferencePictureSets = numberOfReferencePictureSets;
-}
+
+
 
 TComRefPicListModification::TComRefPicListModification()
-: m_bRefPicListModificationFlagL0 (false)
-, m_bRefPicListModificationFlagL1 (false)
+: m_refPicListModificationFlagL0 (false)
+, m_refPicListModificationFlagL1 (false)
 {
   ::memset( m_RefPicSetIdxL0, 0, sizeof(m_RefPicSetIdxL0) );
@@ -3547,20 +3349,22 @@
 TComScalingList::TComScalingList()
 {
-  init();
-}
-TComScalingList::~TComScalingList()
-{
-  destroy();
+  for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
+  {
+    for(UInt listId = 0; listId < SCALING_LIST_NUM; listId++)
+    {
+      m_scalingListCoef[sizeId][listId].resize(min<Int>(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId]));
+    }
+  }
 }
 
 /** set default quantization matrix to array
 */
-Void TComSlice::setDefaultScalingList()
+Void TComScalingList::setDefaultScalingList()
 {
   for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
   {
-    for(UInt listId=0;listId<g_scalingListNum[sizeId];listId++)
-    {
-      getScalingList()->processDefaultMatrix(sizeId, listId);
+    for(UInt listId=0;listId<SCALING_LIST_NUM;listId++)
+    {
+      processDefaultMatrix(sizeId, listId);
     }
   }
@@ -3569,5 +3373,5 @@
  * \returns true if use default quantization matrix in all size
 */
-Bool TComSlice::checkDefaultScalingList()
+Bool TComScalingList::checkDefaultScalingList()
 {
   UInt defaultCounter=0;
@@ -3575,8 +3379,8 @@
   for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
   {
-    for(UInt listId=0;listId<g_scalingListNum[sizeId];listId++)
-    {
-      if( !memcmp(getScalingList()->getScalingListAddress(sizeId,listId), getScalingList()->getScalingListDefaultAddress(sizeId, listId),sizeof(Int)*min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId])) // check value of matrix
-     && ((sizeId < SCALING_LIST_16x16) || (getScalingList()->getScalingListDC(sizeId,listId) == 16))) // check DC value
+    for(UInt listId=0;listId<SCALING_LIST_NUM;listId++)
+    {
+      if( !memcmp(getScalingListAddress(sizeId,listId), getScalingListDefaultAddress(sizeId, listId),sizeof(Int)*min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId])) // check value of matrix
+     && ((sizeId < SCALING_LIST_16x16) || (getScalingListDC(sizeId,listId) == 16))) // check DC value
       {
         defaultCounter++;
@@ -3584,8 +3388,9 @@
     }
   }
-  return (defaultCounter == (SCALING_LIST_NUM * SCALING_LIST_SIZE_NUM - 4)) ? false : true; // -4 for 32x32
-}
-
-#if H_MV
+
+  return (defaultCounter == (SCALING_LIST_NUM * SCALING_LIST_SIZE_NUM )) ? false : true;
+}
+
+#if NH_MV
 Void TComSlice::createInterLayerReferencePictureSet( TComPicLists* ivPicLists, std::vector<TComPic*>& refPicSetInterLayer0, std::vector<TComPic*>& refPicSetInterLayer1 )
 {
@@ -3665,5 +3470,5 @@
 }
 
-TComPic* TComSlice::getPicFromRefPicSetInterLayer(Int setIdc, Int layerId )
+TComPic* TComSlice::getPicFromRefPicSetInterLayer(Int setIdc, Int layerId ) const
 {
   assert ( setIdc == 0 || setIdc == 1);   
@@ -3685,8 +3490,8 @@
 
 
-Int  TComSlice::getRefLayerPicFlag( Int i ) 
-{
-  TComVPS* vps = getVPS(); 
-#if H_3D
+Int  TComSlice::getRefLayerPicFlag( Int i ) const
+{
+  const TComVPS* vps = getVPS(); 
+#if NH_3D
   Int refLayerIdx = vps->getLayerIdInVps( vps->getIdRefListLayer( getLayerId(), i ) ); 
 #else
@@ -3699,9 +3504,9 @@
 }    
 
-Int TComSlice::getRefLayerPicIdc( Int j ) 
+Int TComSlice::getRefLayerPicIdc( Int j ) const
 {  
   Int refLayerPicIdc = -1; 
   Int curj = 0; 
-#if H_3D
+#if NH_3D
   for( Int i = 0;  i < getVPS()->getNumRefListLayers( getLayerId()) ; i++ )
 #else
@@ -3725,8 +3530,8 @@
 }
 
-Int  TComSlice::getNumRefLayerPics( )
+Int  TComSlice::getNumRefLayerPics( ) const
 {  
   Int numRefLayerPics = 0; 
-#if H_3D
+#if NH_3D
   for( Int i = 0;  i < getVPS()->getNumRefListLayers( getLayerId()) ; i++ )
 #else
@@ -3741,5 +3546,5 @@
 
 
-Int TComSlice::getNumActiveRefLayerPics()
+Int TComSlice::getNumActiveRefLayerPics() const
 {
   Int numActiveRefLayerPics; 
